import { GraphQLResolveInfo } from "graphql";
import { PageInfo, Edge } from '.';
import { List, Component } from "..";
import { ConcreteClass } from "../types";
export interface ConnectionArguments {
    before?: string;
    after?: string;
    first?: number;
    last?: number;
}
export declare abstract class Connection<TSource, TArgs extends ConnectionArguments = ConnectionArguments, TContext = {}> extends Component<TSource, TArgs, TContext> {
    protected source: TSource;
    protected args?: TArgs | undefined;
    protected context?: TContext | undefined;
    protected info?: GraphQLResolveInfo | undefined;
    static edgeType?: ConcreteClass<Edge<any>>;
    static nodeType?: any;
    protected static getOrCreatedEdgesType(): List;
    constructor(source: TSource, args?: TArgs | undefined, context?: TContext | undefined, info?: GraphQLResolveInfo | undefined);
    pageInfo: PageInfo;
    edges: any[];
}
